;TIP1218.LSP:     LABEL-R.LSP     Label an Arc     (c)1996, Leland Leahy

;;expects fixed height text style
(defun C:LR (/ ENT PT1 PT2 R A1 A2 PT5A PT5 TEXT)
  (setq
    ENT (entsel "\nChoose radius to label: ")
    PT1 (cadr ENT)
    PT2 (cdr (assoc 10 (entget (car ENT))))
    R (cdr (assoc 40 (entget (car ENT))))
    A1 (angle PT1 PT2)
    A2 (+ A1 (* 0.5 pi))
    PT5A (polar pt1 (angle pt1 pt2) (/ (distance pt1 pt2) 2))
    PT5 (list (car PT5A) (+ (* (getvar "DIMSCALE") 0.066602) (cadr PT5A)))
    TEXT (strcat (rtos R 2 0) "'R") ;;set mode and precision here
  )
  (command ".layer" "m" "genl-text" "") ;;set layer her
  (command ".dim1" "leader" PT1 PT2 ^C)
  (command ".text" "c" PT5 (/ (* 180.0 A1) pi) TEXT)
  (prompt "\nMove text to desired location:")
  (command ".move" "l" "" PT5 pause)
  (prin1)
); end label-r.lsp
