;TIP1219.LSP:     LEGEND.LSP     Automate Your Legends     (c)1996, Leland Leahy

(defun C:LEGEND (/ DS ptt2 ptt3a text_dist ptt3 text)
  (setq
    DS (getvar "dimscale")
    PTT2 (getpoint "\nPick Legend Position: ")
    PTT3A (list (+ (car PTT2) (* 3.0 DS)) (cadr PTT2) 0)
    text_dist (* (* DS 0.1619) 2.0)
    PTT3 (list (car PTT3A) (- (cadr PTT3A) TEXT_DIST) 0)
    TEXT "LEGEND"
  )
  (note)
  (lookfor "CATV" "CABLE TV RISER" 1)
  (lookfor "LIGHT" "LIGHT POLE" 1)
  (lookfor "YD" "YARD DRAIN" 1)
  (lookfor "SBMP" "FND BENCH MARK" 1)
  (lookfor "SMIC" "FND MONUMENT" 1)
  (lookfor "SMICP" "SET MONUMENT" 1)
  (lookfor "SSCP" "FND SECTION CORNER" 1)
  (lookfor "SSC" "CALC'D SECTION CORNER" 1)
  (lookfor "SQCP" "FND QUARTER CORNER" 1)
  (lookfor "SQC" "CALC'D QUARTER CORNER" 1)
  (lookfor "SB" "SOIL BORING" 1)
  (lookfor "PLCORN" "SET REBAR AND CAP #22956" 1)
  (lookfor "PLCORN1" "FND REBAR AND CAP" 1)
  (lookfor "HUB" "HUB" 1)
  (lookfor "ISPR1" "SPINKLER TYPE I" 1)
  (lookfor "ISPR2" "SPINKLER TYPE II" 1)
  (lookfor "ISPR3" "SPINKLER TYPE III" 1)
  (lookfor "IRCV" "REMOTE CONTROL VALVE" 1)
  (lookfor "IEC" "ELECTRONIC CONTROLLER" 1)
  (lookfor "IQCV" "QUICK COUPLING VALVE" 1)
  (lookfor "IDCV" "BACKFLOW DEVICE" 1)
  (lookfor "IPRV" "PRESSURE RELIEF VALVE" 1)
  (lookfor "IRS" "RAIN SENSOR" 1)
  (lookfor "IY" "Y FILTER" 1)
  (lookfor "WMETP" "IRRIGATION METER" 1)
  (lookfor "ITAG" "VALVE TAG" 1)
  (lookfor "SFC" "EX TREE (conifer)" 1)
  (lookfor "SFCP" "TREE (conifer)" 1)
  (lookfor "SFD" "EX TREE (deciduous)" 1)
  (lookfor "SFDP" "TREE (deciduous)" 1)
  (lookfor "SFS" "EX SHRUB" 1)
  (lookfor "SFSP" "SHRUB" 1)
  (lookfor "TREE1" "Misc tree 1" 1)
  (lookfor "TREE2" "Misc tree 2" 1)
  (lookfor "WRED" "EX REDUCER" 1)
  (lookfor "WREDP" "REDUCER" 1)
  (lookfor "WMET" "EX METER" 1)
  (lookfor "WMETP" "METER" 1)
  (lookfor "WFH2" "EX FIRE HYDRANT" 1)
  (lookfor "WFH2P" "FIRE HYDRANT" 1)
  (lookfor "WBOV" "EX BLOW-OFF/AIR VAC" 1)
  (lookfor "WBOVP" "BLOW-OFF/AIR VAC" 1)
  (lookfor "WGV" "EX GATE/BUTTERFLY VALVE" 1)
  (lookfor "WGVP" "GATE/BUTTERFLY VALVE" 1)
  (lookfor "WCROSS" "CROSS" 1)
  (lookfor "WTEE" "TEE" 1)
  (lookfor "WBEND90" "90 BEND" 1)
  (lookfor "WBEND45" "45 BEND" 1)
  (lookfor "WBEND22" "22 1/2 BEND" 1)
  (lookfor "WBEND11" "11 1/4 BEND" 1)
  (lookfor "STCO" "EX CLEAN-OUT" 1)
  (lookfor "STCOP" "CLEAN-OUT" 1)
  (lookfor "CB-I" "EX TYPE I CATCH BASIN" 2)
  (lookfor "CB-IP" "TYPE I CATCH BASIN" 2)
  (lookfor "CB-II" "EX TYPE II CATCH BASIN" 2)
  (lookfor "CB-IIP" "TYPE II CATCH BASIN" 2)
  (lookfor "SSCO" "EX CLEAN-OUT" 1)
  (lookfor "SSCOP" "CLEAN-OUT" 1)
  (lookfor "SSMH" "EX MANHOLE" 2)
  (lookfor "SSMHP" "MANHOLE" 2)
  (lookfor "TJB1" "EX J-BOX TYPE I" 1)
  (lookfor "TJB1P" "J-BOX TYPE I" 1)
  (lookfor "TJB2" "EX J-BOX TYPE II" 1)
  (lookfor "TJB2P" "J-BOX TYPE II" 1)
  (lookfor "TJB3" "EX J-BOX TYPE III" 1)
  (lookfor "TJB3P" "J-BOX TYPE III" 1)
  (lookfor "TPB" "EX PED. PUSH BUTTON" 1)
  (lookfor "TPBP" "PED. PUSH BUTTON" 1)
  (lookfor "TRG" "EX R/R CROSSING GATE" 1)
  (lookfor "TRGP" "R/R CROSSING GATE" 1)
  (lookfor "TRC" "EX R/R SIGNAL" 1)
  (lookfor "TRCP" "R/R SIGNAL" 1)
  (lookfor "TSC" "EX SIGNAL CONTROLLER" 1)
  (lookfor "TSCP" "SIGNAL CONTROLLER" 1)
  (lookfor "TSLA" "EX STREET LIGHT ASSEMBLY" 1)
  (lookfor "TSLAP" "STREET LIGHT ASSEMBLY" 1)
  (lookfor "TSL0" "EX TRAFFIC SIGNAL POLE" 1)
  (lookfor "TSL0P" "TRAFFIC SIGNAL POLE" 1)
  (lookfor "GGV" "EX GAS VALVE" 1)
  (lookfor "GGVP" "GAS VALVE" 1)
  (lookfor "GMET" "EX GAS METER" 1)
  (lookfor "GMETP" "GAS METER" 1)
  (lookfor "PTRAN" "EX PAD MOUNTED TRANSFORMER" 1)
  (lookfor "PTRANP" "PAD MOUNTED TRANSFORMER" 1)
  (lookfor "PV" "EX POWER VAULT" 1)
  (lookfor "PVP" "POWER VAULT" 1)
  (lookfor "UP" "EX UTILITY POLE" 1)
  (lookfor "UPP" "UTILITY POLE" 1)
  (lookfor "TELR" "EX TELEPHONE RISER" 1)
  (lookfor "TELRP" "TELEPHONE RISER" 1)
  (lookfor "TV" "EX TELEPHONE VAULT" 1)
  (lookfor "TVP" "TELEPHONE VAULT" 1)
  (lookfor "SFMB" "EX MAILBOX" 1)
  (lookfor "SFMBP" "MAILBOX" 1)
  (lookfor "SFR" "EX ROCKERY" 1)
  (lookfor "SFRP" "ROCKERY" 1)
  (lookfor "SFSN" "EX SIGN" 1)
  (lookfor "SFSNP" "SIGN" 1)
  (lookfor "GP" "EX GUARD POST" 1)
  (lookfor "GPP" "GUARD POST" 1)
  (looklayer "EX DITCHES/SWALES/STREAMS" "X-SWAL-LINE" "LA-SWAL")
  (looklayer "EX MAJOR CONTOURS" "X-MAJR-CONT" "LA-MAJR")
  (looklayer "EX MINOR CONTOURS" "X-MINR-CONT" "LA-MINR")
  (looklayer "CONTOUR" "CONT-LINE" "LA-CONT")
  (looklayer "DITCHES/SWALES/STREAMS" "SWAL-LINE" "LA-SWAL2")
  (looklayer "LIMITS OF CLEARING" "TLIM-LINE" "LA-TLIM")
  (looklayer "SILT FENCE" "SILT-LINE" "LA-SILT")
  (looklayer "TEMPORARY DITCH" "TDIT-LINE" "LA-TDIT")
  (looklayer "EX EDGE OF GRAVEL SHOULDER" "X-GRVL-LINE" "LA-GRVL")
  (looklayer "EX EDGE OF PAVEMENT" "X-EPAV-LINE" "LA-EPAV")
  (looklayer "ASPHALT" "ASPH-LINE" "LA-ASPH")
  (looklayer "SAW CUT LINE" "SAWC-LINE" "LA-SAWC")
  (looklayer "EX SANITARY SEWER LINE" "X-SSWR-LINE" "LA-SSWR")
  (looklayer "SANITARY SEWER LINE" "SSWR-LINE" "LA-SSWR2")
  (looklayer "EX STORM LINE" "X-STRM-LINE" "LA-STRM")
  (looklayer "STORM LINE" "STRM-FILL" "LA-STRM2")
  (looklayer "EX WATER LINE" "X-WATR-LINE" "LA-WATR")
  (looklayer "WATER LINE" "WATR-LINE" "LA-WATR2")
  (looklayer "EX UTILITY LINE" "X-UTIL-LINE" "LA-UTIL")
  (looklayer "UTILITY LINE" "UTIL-LINE" "LA-UTIL2")
  (looklayer "FENCE" "FENC-LINE" "LA-FENC")
  (prin1)
)
;--------------------------------------------------------------------
(defun lookfor (SYM NAME SCALE / BLK BLKNAME )
  (if (= SCALE 1)
    (setq SCALE2 (getvar "DIMSCALE"))
    (setq SCALE2 1)
  )
  (tblnext "BLOCK" T)
  (while
    (setq BLK (tblnext "BLOCK"))
    (setq BLKNAME (cdr (assoc 2 BLK)))
    (if (= BLKNAME SYM)
      (progn
        (setq TEXT NAME)
        (NOTE)
        (SYM2 SYM SCALE2)
      )
    )
  )
)
;--------------------------------------------------------------------
(defun LOOKLAYER (NAME LAY LAYSYM / LA LANAME )
  (tblnext "LAYER" T)
  (while
    (setq LA (tblnext "LAYER"))
    (setq LANAME (cdr (assoc 2 LA)))
    (if (= LANAME LAY)
      (progn
        (setq TEXT NAME)
        (NOTE)
        (SYM3 LAYSYM)
      )
    )
  )
)
;--------------------------------------------------------------------
(defun note ()
  (command ".text" PTT2 0 TEXT)
  (setq
    PTT2 (LIST (CAR PTT2) (- (cadr PTT2) TEXT_DIST) 0)
  )
)
;--------------------------------------------------------------------
(defun sym2 (T SCA / S)
  (setq S (strcat  T))
  (command ".insert" S PTT3 SCA SCA "0")
  (setq
    PTT3 (list (car PTT3) (- (cadr PTT3) TEXT_DIST) 0)
  )
)
;--------------------------------------------------------------------
(defun sym3 (T / S)
  (setq S (strcat T))
  (command ".insert" S PTT3 (/ DS 20.0) (/ DS 20.0) "0")
  (setq
    PTT3 (list (car PTT3) (- (cadr PTT3) TEXT_DIST) 0)
  )
)
;--------------------------------------------------------------------
(prompt "\nType Legend to start")
(prin1); end legend.lsp
